#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#include "file_de_prio.h"

// ATTENTION ceci est une implémentation NAIVE de file de priorité
// où les éléments sont stockés sous la forme de liste chaînée

//constructeur
file_prio cree_file_prio_vide(){
	return NULL; //la lsite chainée vide
}

//accesseurs
bool est_file_prio_vide(file_prio fp){
	return fp == NULL;
}

float prio_min (file_prio fp){
	//hyp : not est_file_prio_vide fp
	cellule* pc = fp;
	float p_min = pc->p;
	while(pc->next != NULL){
		pc = pc->next;
		if (pc->p < p_min)
			p_min = pc->p;
	}
	return p_min;
}

int elem_min (file_prio fp){
	//hyp : not est_file_prio_vide fp
	cellule* pc = fp;
	float p_min = pc->p;
	int elem_min = pc->s;
	while(pc->next != NULL){
		pc = pc->next;
		if (pc->p < p_min){
			p_min = pc->p;
			elem_min = pc->s;
		}
	}
	return elem_min;
}

bool contient_elem (file_prio fp, int elem){
	return contient_sommet(fp,elem);
}

//transformateurs
void supprime_min (file_prio* p_fp){
	// hyp : ! est_file_prio_vide(*p_fp)
	// supprime un élément de priorité minimale de *p_fp
	cellule* pc = *p_fp; //l'adresse de la cellule courante
	liste_c* ppc = p_fp; //là où est enregistrée l'adresse de la cellule *pc
	//inv : *ppc = pc 
	float p_min = pc->p;
	liste_c* ppc_min = ppc; //là où est enregistrée l'adresse de la cellule de prio p_min
	while(pc->next != NULL){
		ppc = &(pc->next);
		pc = pc->next;
		if (pc->p < p_min){
			p_min = pc->p;
			ppc_min = ppc;
		}
	}
	//la cellule à supprimer est à l'adresse *ppc_min
	cellule* c_to_del = *ppc_min;
	//donc à l'adresse ppc_min on met l'adresse de la cellule suivante
	*ppc_min = c_to_del->next;
	//puis on libère l'espace
	free(c_to_del);
}

void ajoute_elem  (file_prio* p_fp, int elem, float prio){
	//ajoute elem avec la priorité prio à la file *p_fp passée par réf.
	ajoute_debut(p_fp,elem,prio);
}

void diminue_prio (file_prio fp, int elem, float prio){
	//hyp : contient_elem(fp,elem) et prio <= à la priorité associée à elem dans fp
	//modifie la priorité de elem dans fp
	cellule* pc = fp;
	bool pas_trouve = true;
	while(pc->next != NULL && pas_trouve){
		pc = pc->next;
		if (pc->s == elem){
			pc->p = prio;
			pas_trouve = false;
		}
	}
}
