#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <stdbool.h>

struct s_cellule{
	int s; //sommet représenté 
	float p; //pondération ou priorité selon les usages
	struct s_cellule* next; //adresse de la cellule suivante
	//ou NULL si c'est la dernière cellule de la liste
};

typedef struct s_cellule cellule;
typedef cellule* liste_c;


// fonctions de création et de suppression/libération
cellule* create_cell(int sommet, float poids);
liste_c create_from_tabs(int* tab_sommets,float* tab_poids, int lg);
void free_liste_c(liste_c l);

// fonction d'accès
void affiche_liste(liste_c l);
int nb_elem(liste_c l);
bool contient_sommet(liste_c l,int sommet);

// fonctions de modification
// ATTENTION la liste est passée par référence et non par valeur
// aux transformateurs, d'où le type liste_c*
void ajoute_debut(liste_c* ptr_l, int sommet, float poids);

